{#-#####################################################################
 # Jinja2 template for /etc/rc.conf.d/netif
 #======================================================================
 # Helper macros for FreeBSD ifconfig commands
 ####################################################################-#}
{#======================================================================
 # format_inet4_address
 #----------------------------------------------------------------------
 # This macro formats a static IPv4 address definition to a string
 # compatible with ifconfig commands. The formatted string is then
 # echoed back. If the supplied address definition is invalid, the
 # macro echoes nothing.
 #
 # The formatted string is built in the form of:
 #    <address> netmask <netmask>[ broadcast <broadcast>]
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - inet_address (fr.pep06.schemas.network.address)
 #      The address definition to process.
 #===================================================================-#}
{%- macro format_inet4_address(inet_address) -%}
  {%- set buffer = [] -%}

  {#- Build address values -#}
  {%- if inet_address['protocol'] == 'inet4' -%}
    {%- set address = inet_address['address']
        | ipv4('host/prefix')
        | ipaddr('address')
    -%}

    {%- set netmask = inet_address['address']
        | ipv4('host/prefix')
        | ipaddr('netmask')
    -%}
  {%- endif -%}

  {#- We only proceed if both an address and a netmask are defined -#}
  {%- if address and netmask -%}
    {#- Append host address in dotted notation -#}
    {{ buffer.append(address) }}
    {#- Append netmask in hex notation -#}
    {{ buffer.append('netmask ' ~ netmask) }}
  {%- endif -%}

  {#- Format and echo the inet4 address -#}
  {%- if buffer -%}
    {{ buffer | join(" ") }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Format inet6 address
 #----------------------------------------------------------------------
 # This macro formats a static IPv6 address definition to a string
 # compatible with ifconfig commands. The formatted string is then
 # echoed back. If the supplied address definition is invalid, the
 # macro echoes nothing.
 #
 # The formatted string is built in the form of:
 #    <address> netmask <netmask>[ broadcast <broadcast>]
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - inet_address (fr.pep06.schemas.network.address)
 #      The address definition to process.
 #===================================================================-#}
{%- macro format_inet6_address(inet_address) -%}
  {%- set buffer = [] -%}

  {#- Build address values -#}
  {%- if inet_address['protocol'] == 'inet6' -%}
    {%- set address = inet_address['address']
        | ipv6('host/prefix')
        | ipaddr('address')
    -%}
    {%- set prefix_length = inet_address['address']
        | ipv6('host/prefix')
        | ipaddr('prefix')
    -%}
  {%- endif -%}

  {#- We only proceed if both an address and a netmask are defined -#}
  {%- if address and prefix_length -%}
    {#- Append host address in hexadecimal notation -#}
    {{ buffer.append(address) }}
    {#- Append prefix length as an integer value -#}
    {{ buffer.append('prefixlen ' ~ prefix_length) }}
  {%- endif -%}

  {#- Format and echo the inet4 address -#}
  {%- if buffer -%}
    {{ buffer | join(" ") }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # get_inet4_options
 #----------------------------------------------------------------------
 # This macro builds a list of ifconfig options related to the IPv4
 # protocol, then echoes this list as a JSON string.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The definition of the network interface to process.
 #===================================================================-#}
{%- macro get_inet4_options(interface) -%}
  {%- set options = [] -%}

  {#- We only proceed if IPv4 is enabled on the interfce -#}
  {%- if  'inet4' in interface
      and 'enabled' in interface['inet4']
      and interface['inet4']['enabled']
  -%}

    {#- Append main static address, if static addressing is enabled -#}
    {%- if  'static' in interface['inet4']
        and 'enabled' in interface['inet4']['static']
        and interface['inet4']['static']['enabled']
    -%}
      {#- Get a list of IPv4 static addresses for the interface -#}
      {%- set static_addresses =
            common.get_interface_inet_addresses(interface, 'inet4')
            | from_json -%}

      {#- If at least one static address was found, go ahead -#}
      {%- if static_addresses | length > 0 -%}
        {#- Default is to use the first address in the list -#}
        {%- set main_address = static_addresses[0] -%}
        {#- Format the main IPv4 address -#}
        {%- set formatted_addr = format_inet4_address(main_address) -%}
        {%- if formatted_addr -%}
          {{ options.append(formatted_addr) }}
        {%- endif -%}
        {#- Store the main address -#}
      {%- endif -%}
    {%- endif -%}

  {%- endif -%}

  {{ options | to_json }}

{%- endmacro -%}

{#======================================================================
 # Get inet6 options
 #----------------------------------------------------------------------
 # This macro builds a list of ifconfig options related to the IPv6
 # protocol, then echoes this list as a JSON string.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The definition of the network interface to process.
 #===================================================================-#}
{%- macro get_inet6_options(interface) -%}
  {%- set options = [] -%}

  {#- We only proceed if IPv6 is enabled on the interfce -#}
  {%- if  'inet6' in interface
      and 'enabled' in interface['inet6']
      and interface['inet6']['enabled']
  -%}

    {#- Append main static address, if static addressing is enabled -#}
    {%- if  'static' in interface['inet6']
        and 'enabled' in interface['inet6']['static']
        and interface['inet6']['static']['enabled']
    -%}
      {#- Get a list of IPv6 static addresses for the interface -#}
      {%- set static_addresses =
            common.get_interface_inet_addresses(interface, 'inet6')
            | from_json -%}
      
      {#- If at least one static address was found, go ahead -#}
      {%- if static_addresses | length > 0 -%}
        {#- Default is to use the first address in the list -#}
        {%- set main_address = static_addresses[0] -%}
        {#- Format the main IPv4 address -#}
        {%- set formatted_addr = format_inet6_address(main_address) -%}
        {%- if formatted_addr -%}
          {{ options.append(formatted_addr) }}
        {%- endif -%}
        {#- Store the main address -#}
      {%- endif -%}
    {%- endif -%}

  {%- endif -%}

  {{ options | to_json }}
{%- endmacro -%}

{#======================================================================
 # Get interface options
 #----------------------------------------------------------------------
 # This macro builds a list of ifconfig options related to the
 # interface itself.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The definition of the network interface to process.
 #===================================================================-#}
{%- macro get_interface_options(interface) -%}
  {%- set options = [] -%}

  {#- Always enable link on boot -#}
  {{ options.append("up") }}

  {{ options | to_json }}
{%- endmacro -%}

{#======================================================================
 # get_keywords
 #----------------------------------------------------------------------
 # This macro builds a list of ifconfig keywords for the supplied
 # interface, and echoes the list as a JSON string. ifconfig keywords
 # are built in the scope of a whole interface.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The definition of the network interface to process.
 #===================================================================-#}
{%- macro get_keywords(interface) -%}
  {%- set keywords = [] -%}

  {#- Add 'NOAUTO' to interface which should not be started on boot -#}
  {%- if 'autostart' not in interface
      or 'on_boot' not in interface['autostart']
      or interface['autostart']['on_boot'] == false
  -%}
    {{ keywords.append("NOAUTO") }}
  {%- endif -%}

  {#- DHCP -#}
  {%- if  'inet4' in interface
      and 'enabled' in interface['inet4']
      and interface['inet4']['enabled']
      and 'dhcp' in interface['inet4']
      and 'enabled' in interface['inet4']['dhcp']
      and interface['inet4']['dhcp']['enabled']
  -%}
    {{ keywords.append("DHCP") }}
  {%- endif -%}

  {{ keywords | to_json }}
{%- endmacro -%}

{#-=====================================================================
 # macro get_lagghash
 #======================================================================
 # Return the value of the 'lagghash' ifconfig attribute from a bond
 # interface definition.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The network interface to process.
 #----------------------------------------------------------------------
 # Mapping table
 #----------------------------------------------------------------------
 #  ['l2']              --> 'l2'
 #  ['l2', 'l3']        --> 'l2,l3'
 #  ['l2', 'l3', 'l4']  --> 'l2,l3,l4'
 #  ['l2', 'l4']        --> 'l2,l4'
 #  ['l3']              --> 'l3'
 #  ['l3', 'l4']        --> 'l3,l4'
 #===================================================================-#}
{%- macro get_lagghash(interface) -%}
  {%- set sources = [] -%}
  {%- if 'hash_sources' in interface['bond'] -%}
    {%- if 'l2' in interface['bond']['hash_sources'] -%}
      {{ sources.append('l2') }}
    {%- endif -%}
    {%- if 'l3' in interface['bond']['hash_sources'] -%}
      {{ sources.append('l3') }}
    {%- endif -%}
    {%- if 'l4' in interface['bond']['hash_sources'] -%}
      {{ sources.append('l4') }}
    {%- endif -%}
    {{ sources | join(',') }}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro get_laggproto
 #======================================================================
 # Return the value of the 'laggproto' ifconfig attribute from a bond
 # interface definition.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The network interface to process.
 #===================================================================-#}
{%- macro get_laggproto(interface) -%}
  {%-   if interface['bond']['mode'] == 'broadcast' -%}
    {{ 'broadcast' }}
  {%- elif interface['bond']['mode'] == 'failover' -%}
    {{ 'failover' }}
  {%- elif interface['bond']['mode'] == 'hash' -%}
    {{ 'loadbalance' }}
  {%- elif interface['bond']['mode'] == 'lacp' -%}
    {{ 'lacp' }}
  {%- elif interface['bond']['mode'] == 'roundrobin' -%}
    {{ 'roundrobin' }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # get_link_options
 #----------------------------------------------------------------------
 # This macro builds a list of ifconfig options related to the link
 # layer, then echoes this list as a JSON-encoded list.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The definition of the network interface to process.
 #===================================================================-#}
{%- macro get_link_options(interface, indexes) -%}
  {%- set options = [] -%}

  {#- Check whether the interface is enabled -#}
  {%- if 'disabled' in interface and interface['disabled'] -%}
    {%- set interface_is_enabled = false -%}
  {%- else -%}
    {%- set interface_is_enabled = true -%}
  {%- endif -%}

  {#- We only process link options for enabled interfaces -#}
  {%- if interface_is_enabled -%}
    {%- if 'ethernet' in interface -%}

      {#- Ethernet MTU -#}
      {%- if 'mtu' in interface['ethernet'] -%}
        {{ options.append("mtu " ~ interface['ethernet']['mtu']) }}
      {%- endif -%}

      {#- Ethernet address -#}
      {%- if 'address' in interface['ethernet'] -%}
        {{ options.append(
            "address " ~ interface['ethernet']['address']) }}
      {%- endif -%}

    {%- endif -%}
  {%- endif -%}

  {{ options | to_json }}
{%- endmacro -%}
